<template>
  <div class="score-list">
    <ul
      v-for="elQuestionAnswer in this.questionAnswerList"
      :key="elQuestionAnswer[0].question"
    >
      <li class="result-list">
        <span
          v-html="elQuestionAnswer[0].question"
          :class="{ active: elQuestionAnswer[2] }"
        ></span>
        <br />
        <br />

        <div class="answers">
          <div>
            <span> You answered:</span>
            <span v-html="elQuestionAnswer[1]"></span>
          </div>
          <div>
            <span> Correct answer is:</span>
            <span v-html="elQuestionAnswer[0].correctAnswer"></span>
          </div>
        </div>
      </li>
    </ul>

    <div class="score-results">
      <h2>Summary</h2>
      <ul class="summary-list">
        <li>
          Points:
          {{ this.score }}
        </li>
        <li>
          Correct:
          {{ this.correct }}
        </li>
        <li>Wrong: {{ this.wrong }}</li>
        <li>Percentage correct: {{ this.percentageCorrect + "\%" }}</li>
        <li>Number of questions answered: {{ this.total }}</li>
      </ul>
      <button @click="redirectToGame">Play again!</button>
    </div>
  </div>
</template>
<script>
import { mapGetters, mapMutations, mapState } from "vuex";
export default {
  name: "Score",
  data() {
    return {
      score: 0,
      correct: 0,
      wrong: 0,
      total: this.$store.state.questionsAnswered,
      percentageCorrect: 0,
      questionAnswerList: [],
    };
  },

  created() {
    this.evaluateAnswers(this.questions, this.answers);
  },
  computed: {
    ...mapState(["questions", "questionsAnswered", "answers"]),
  },

  methods: {
    ...mapGetters([
      "getAnswerOptions",
      "getQuestion",
      "getQuestionsLength",
      "getQuestions",
    ]),
    ...mapMutations(["resetState"]),

    computeScore(numberOfQuestionsCorrect, difficultyWeight) {
      this.correct = numberOfQuestionsCorrect;
      this.wrong = this.total - this.correct;
      this.score = this.correct * difficultyWeight;
    },
    computeScorePercentage() {
      this.percentageCorrect = (this.correct / this.total) * 100;
    },
    getPoints() {
      return this.$store.state.answers;
    },
    incrementCorrect() {
      this.correct += 1;
    },

    isCorrectAnswer(solution, answer) {
      return solution === answer;
    },
    evaluateAnswers(questions, answers) {
      for (let i = 0; i < questions.length; i++) {
        //console.log(questions[i].correctAnswer, questions[i].allAnswers);

        if (questions[i].correctAnswer === answers[i]) {
          this.questionAnswerList.push([questions[i], answers[i], true]);
          this.incrementCorrect();
        } else {
          this.questionAnswerList.push([questions[i], answers[i], false]);
        }
      }
      //console.log(this.$store.state.questionsAnswered);
      this.computeScore(this.correct, 10);
      this.computeScorePercentage();
    },

    redirectToGame() {
      this.resetState();
      this.$router.push({ path: "/" });
    },
  },
};
</script>

<style>
.score-list {
  color: rgb(235, 80, 9);
  text-decoration: none;
  display: flexbox;
  align-items: center;
  margin-bottom: 1em;
  padding: 0.75em 0.5em;
}

.score-list ul {
  border-bottom: 0.1em solid #857d7d;
  padding: 0.55em 0.5em;
}

.active {
  color: rgb(22, 224, 99);
}

.score-results {
  color: rgb(0, 5, 2);
}

.score-correct-answer ul {
  color: rgb(0, 5, 2);
}

.score-results ul {
  color: rgb(0, 5, 2);
  border-bottom: 0em;
}

.summary-list {
  list-style-type: none;
}
.result-list {
  list-style-type: none;
}
.answers {
  color: rgb(0, 5, 2);
}
</style>
